<%@ Page Language="C#" AutoEventWireup="true"    %>
<%@ Register TagPrefix="SF" Namespace="SharpForge.Web.UI" Assembly="__Code" %>
<html>
<head>
  <link href="style.css" type="text/css" rel="stylesheet" />
  <title>SexyHyperLink and SexyLinkButton Asp.Net Server Controls</title>
	    <style type="text/css">
<!--
/******************
Sexy CSS Buttons
 http://www.oscaralexander.com/tutorials/how-to-make-sexy-buttons-with-css.html
******************/

.clear { /* generic container (i.e. div) for floating buttons */
    overflow: hidden;
    width: 100%;
}

/* The right end */
a.button {
    background: transparent url('images/bg_button_right.gif') no-repeat scroll top right;
    color: #444;
    display: block;
    float: left;
    font: normal 12px arial, sans-serif;
    height: 27px;
    margin-right: 6px;
    padding-right: 18px; /* sliding doors padding */
    text-decoration: none;
}

/* The left end and the stretchy bit */
a.button span {
    background: transparent url('images/bg_button_left.gif') no-repeat;
    display: block;
    line-height: 21px;
    padding: 6px 0 0px 18px;
}


/* These give the clicked state */
a.button:active {
    background-position: bottom right;
    color: #000;
    outline: none; /* hide dotted outline in Firefox */
}

a.button:active span {
    background-position: bottom left;
    padding: 6px 0 0px 18px; 
}




/******************
Unrelated to tutorial
******************/

body {
	font-family:Geneva, Arial, Helvetica, sans-serif;
	color:#333;
	margin:15px 40px;
	font-size: 12px;
	line-height: 1.4em;
	}


-->
        </style>
	</head>

</head>
<body>
<p>
This tutorial will show you how you can make your HyperLink's and LinkButton's into SexyHyperLink's and SexyLinkButton's. 
Making text based css buttons, with an alternate pressed state and also using and freely available icons. No javascript required.
These dynamic buttons will save you heaps of time. 
<br />
<br />To start using them now download this demo project.
</p>
Heres an example of what you can expect when using these controls. The first three are hyperlinks and the fourth is a link button.
<br />
<br>
 <div>
         <SF:SexyHyperLink runat="server" Text="Sexy asp.net button tutorial" ImageUrl="~/Images/information.png" cssclass="button" NavigateUrl="~"></SF:SexyHyperLink>
         <SF:SexyHyperLink ID="SexyHyperLink1" runat="server" ImageUrl="~/Images/folder.png" cssclass="button" NavigateUrl="http://www.famfamfam.com/lab/icons/silk/previews/index_abc.png"></SF:SexyHyperLink>
         <SF:SexyHyperLink ID="SexyHyperLink2" runat="server" Text="No icon here" cssclass="button" NavigateUrl="http://www.oscaralexander.com/tutorials/how-to-make-sexy-buttons-with-css.html"></SF:SexyHyperLink>
         <SF:SexyLinkButton ID="SexyLinkButton1" runat="server" Text="Smack me" ImageUrl="~/Images/sport_soccer.png" ></SF:SexyLinkButton>
 </div>
<br><br>         
<p>
<h2>Background</h2>
In my spare time I run an open source project (<a href="http://sharpforge.org/p/SharpForge.aspx">SharpForge</a>) which currently has all standard text hyperlink and linkbuttons. 
There have been quite a few requests to make it look and feel more attractive. While researching I discovered the tutorial by Oscar and found that making the css buttons was quite easy. 
The silk icons were also recommended so I tried combining the two. It looked really cool so I set about creating reusable server controls. 
<br /><br />
This solution takes what is provided by Oscar Alexandar's <a href='http://www.oscaralexander.com/tutorials/how-to-make-sexy-buttons-with-css.html'>how to make sexy buttons with css</a>
and the <a href='http://www.famfamfam.com/lab/icons/silk/'>silky icons provided for free at FAMFAMFAM</a> and wraps the HyperLink and LinkButton controls into easy to use server controls. 
</p>
<br />
<p>
<h2>Sexy CSS</h2>
I'm not going to go into the detail of the CSS since that's explained very well in <a href='http://www.oscaralexander.com/tutorials/how-to-make-sexy-buttons-with-css.html'>Oscars tutorial</a>. 
The points to note are:
<ul>
  <li>it uses a technique called <a href="http://www.alistapart.com/articles/slidingdoors/">sliding doors</a> which involves two images. This technique allows the button to stretch horizontally</li>
  <li>the two states(clicked and not clicked) of the button are on each of the images. When the button is clicked the image is moved horizontally to show the alternate state. No javascript is required for this.</li>
  <li>the links in this demo are using the css class "button"</li>
</ul>

<br>
<h2>Silky Icons</h2>
There are <i>loads</i> of cool free icons at FAMFAMFAM that you can download and use with this control right now. 
<a href="http://www.famfamfam.com/lab/icons/silk/previews/index_abc.png">View all of the Silk icons here</a>.
<br>
</p>
<br>
<h2>SexyHyperLink</h2>
<p>
Armed with a working example of how to achieve the sexy buttons and some free icons, making a server control was 
quite straight forward. Thus the SexyHyperLink was born by wrapping the normal hyperlink with a span and the icon. 

Therefore the tag....
<pre>      
         &lt;SF:SexyHyperLink runat="server" Text="Sexy asp.net button tutorial" ImageUrl="~/Images/information.png" cssclass="button" NavigateUrl="~" />
</pre>

Outputs the following html...
<pre>      
         &lt;a href="./" class="button">&lt;span>&lt;img src="Images/information.png" style="border-width:0px;" />&nbsp;Sexy asp.net button tutorial&lt;/span>&lt;/a>
</pre>


<br>
<h2>SexyLinkButton</h2>
<p>
The link button works in almost the exact same manner.
</p>
<pre>
         &lt;SF:SexyLinkButton runat="server" Text="Smack me" ImageUrl="~/Images/sport_soccer.png" />
</pre>

Renders...
<pre>
	&lt;a href="javascript:__doPostBack('ctl06','')"><b>&lt;span>&lt;img src="Images/sport_soccer.png" style="border-width:0px;" />&nbsp;</b>Smack me<b>&lt;/span>&lt;</b>/a>
</pre>


Each of the controls inherits the corresponding link and the only additional properties are ImageUrl and Icon for accessing the icon image. 
Setting the CssClass is important because it associates our control with the style sheet configuration. I haven't displayed the rendering code for the 
server controls because it's very straight forward, you can see it in the app_code folder.<br />
<br />
And that is it. They're not complicated so now there's no excuses for ugly buttons. <br /> 
<br />
<h2>About SharpForge</h2>

<a href="http://sharpforge.org/p/SharpForge.aspx">SharpForge</a> is a C#, ASP.Net 2.0, Subversion open source project management web application. 
It's goal is to provide SourceForge or Codeplex like project hosting functionality but for everyone and anyone. In the next release it 
will have some shiny new buttons :)

</body>
</html>